****************************************************
*
; BouQLder QLash
; this initialises my work area with many values
; (C) W. Lenerz 2018
*
*****************************************************

	section basic

	include 'dev1_basic_boulder_asm_keys'
	include 'dev8_keys_qlv'
	include 'dev8_keys_err'
	include 'dev8_keys_sbasic'
	include 'DEV8_keys_con'
	include 'DEV8_keys_sss'
	include 'DEV8_keys_sys'
					      

	xdef	bd_init

	xref	ani_tbl32
	xref	ani_tbl16

;*****************************************************************
;
; BD_INIT	work_area, gen_sprites,white_alpha,yellow_alpha,
;		spr_xsize,sp_ysize,machine*65536+chan_nbr,sounds,arr_spce,
;		disp_type
;
;*****************************************************************

errbp	moveq	#err.ipar,d0
	rts

bd_init move.w	sb.gtlin,a2
	jsr	(a2)			; get long integers
	cmp.w	#10,d3			; there must be that many
	bne.s	errbp			; but there weren't
	mulu	#4,d3
	add.l	d3,sb_arthp(a6) 	; adjust maths stack
	move.l	(a6,a1.l),a5		; pointer to work space
	move.l	a5,a0
	move.l	4(a6,a1.l),(a0)+	; general sprites
	move.l	8(a6,a1.l),(a0)+	; white alpha
	move.l	12(a6,a1.l),(a0)+	; yellow alpha
	addq.l	#4,a0			; jump over timer
	move.l	18(a6,a1.l),d0		; spr xsize in upper word!
	move.w	22(a6,a1.l),d0		; y size in lower word
	move.l	d0,(a0)+
	add.w	d0,d0
	move.l	d0,(a0)+		; x,y offsets

getchan move.l	24(a6,a1.l),d0		; machine | channel nbr
	move.l	d0,d1
	move.l	sb_chanb(a6),a2 	; sbasic channel table
	mulu	#ch.len,d0		; size of one entry in table
	add.l	d0,a2			; point to entry
	cmp.l	sb_chanp(a6),a2 	; don't overshoot end of table!
	bge.s	errbp
	move.l	(a6,a2.l),d0		; channel ID
	blt.s	errbp			; if neg, channel is closed
	move.l	d0,(a0)+		; keep channel ID

	swap	d1
	sub.w	#$14,d1
	move.b	d1,machine(a5)		; Z forSMSQmulator, NZ for all others
	beq.s	setfast
	subq.w	#4,d1			; if qpc will be 0
setfast move.b	d1,fast(a5)		; 0 for QPC and SMSQmulator, else <>0
	move.l	28(a6,a1.l),snd_dta(a5) ; sound data
	move.l	32(a6,a1.l),a4		; space for array data
	moveq	#rowsize+2,d0
	add.l	d0,a4			; jump over the first row (all 0)
	add.l	d0,a4			; and over the secord row, this is steel wall
	move.l	a4,(a0) 		; keep

	move.b	39(a6,a1.l),display(a5) ; display type (16,32,33)

; preset parameters for the keyrow call
	lea	keybfr(a5),a0
	move.w	#$0901,(a0)+		; keyrow
	clr.l	(a0)+			; four bits
	move.w	#$0102,(a0)		; keyrow 1, eight bit reply

; calculate and preset many parmas for the screen/window
	moveq	#0,d0
	trap	#1			; get sys vars into A0
	move.l	sys_clnk(a0),d0 	; pointer linkage
	beq	errbp			; there is none?
	move.l	d0,a0
	moveq	#0,d6
	move.w	pt_scinc(a0),d4 	; d4 = screen row increment in bytes
	move.w	d4,scr_inc(a5)		; screen line length in bytes
	move.w	d4,d6

	divu	pt_xscrs(a0),d6 	; d6 = nbr of bytes per pixel
	move.w	d6,scr_byt(a5)
	move.w	d6,d0
	rol.w	#8,d0
	move.w	d0,spr_inc(a5)		; distance from one sprite to another, either 512 or 256 bytes
	move.l	pt_scren(a0),d7 	; point to screen base
	moveq	#-1,d3
	lea	xtop,a2
	move.l	chanID(a5),a0
	moveq	#9,d0			; iow.xtop
	trap	#3			; to get wdw (x|y) origin into d1
	move.w	d1,d0			; wdw y orig
	mulu	d4,d0			; * bytes per screen line
	add.l	d0,d7
	swap	d1			; wdw x orig
	mulu	d6,d1			; * bytes per pixel
	add.l	d1,d7
	move.l	d7,scr_add(a5)		; screen address of my wdw
	move.w	d4,d5
	mulu	sp_ysiz(a5),d5		; offset to row with border
	add.l	d7,d5
	move.l	d5,scr_off(a5)		; start of playing field
	lea	ani_tbl32,a0		; preset sprites for 16 bit pixels
	cmp.w	#2,d6			; choose the correct sprite table
	beq.s	put_tbl 		; for this windows mode
	lea	ani_tbl16,a0		; 8 bit sprites
put_tbl move.l	a0,spr_tbl(a5)
	mulu	sp_xsiz(a5),d6		; d6 = sprite x size in bytes
	move.w	d6,spr_lsz(a5)		; nbr of bytes per sprite line
	sub.w	d6,d4			; length of 1 screen row - x size of sprite
	move.w	d4,scr_spinc(a5)	; row increase to next line of sprite
	add.l	d6,d5
	divu	#4,d6			; nbr of long words to copy 1 sprite line
	subq.w	#1,d6			; prepared for dbf
	move.w	d6,scr_lop(a5)		;
; get/set sound vector
exv_i4	equ	$0070			; Interrupt level 4
sf3	clr.l	ssss(a5)
	move.l	exv_i4,a3		; point to Interrupt level 4
	move.l	-(a3),a2		; this could be SSSS vector
	cmp.l	#sss.flag,-(a3) 	; is it really?
	bne.s	exit			; no!
	movem.l a2/a3,ssss(a5)
exit	moveq	#0,d0
	rts

xtop	move.l	$18(a0),d1		; get wdw orig
	moveq	#0,d0
	rts

	end


	end
