********************************************************************
*
; BouQLder QLash
; BD_SNDF - Load a sound file and play it, perhaps continuously.
; This is a near copy of my smsqe soundfile2 command for smsqmulator
* BD_SKILL - kill sound playing job
; (C) W. Lenerz 2018
*
********************************************************************

	section sound

	include dev8_keys_qdos_sms
	include dev8_keys_err
	include dev8_keys_sbasic
	include dev8_keys_qlv
	include dev8_keys_sss
	include dev8_keys_68000
	include DEV8_keys_qdos_io
	include DEV8_keys_qdos_ioa
	include dev1_basic_boulder_asm_keys
	include dev1_basic_boulder_asm_snd_keys

	xdef	bd_sndf
	xdef	bd_skill

	xref	sound			; in suond_asm
	xref	rt_fp			; in bdsprt_asm

sndregs reg	a1/a2/a4/d5
			       
***********************************************************
*
*	BD_SKILL jobID
*	kill the job and stop the sound
*
***********************************************************
bd_skill
	move.w	sb.gtlin,a2
	jsr	(a2)			; get one long int
	bne.s	errbp
	subq.w	#1,d3			; exactly one?
	bne.s	errbp
	move.l	(a6,a1.l),d1		;
	addq.l	#4,sb_arthp(a6)
	moveq	#0,d3			; pretend no error occurred
	moveq	#sms.frjb,d0		; kill job (also closes channel)
	trap	#1

	move.l	exv_i4,a3		; point to Interrupt level 4
	move.l	-(a3),a2		; this could be SSSS vector
	cmp.l	#sss.flag,-(a3) 	; is it really?
	bne.s	bd_skout		; ... no!
	jsr	sss_kill(a2)
bd_skout
	moveq	#0,d0
	rts


***********************************************************
*
*	jobID=BD_SNDF (cont%*65536+machine%, name_of_file$)
*	machine is smsqmulator, else <>0
*	cont%=1 if sound should play continously, (use bd_skill to stop)
*
***********************************************************
errbp	moveq	#err.ipar,d0
	rts
bd_sndf
	subq.l	#8,a5
	move.w	sb.gtlin,a2
	jsr	(a2)			; get one long int
	bne.s	errbp
	subq.w	#1,d3			; exactly one?
	bne.s	errbp			; ... no
	move.l	(a6,a1.l),d7		; keep
	addq.l	#4,sb_arthp(a6)
	move.l	a5,a3
	addq.l	#8,a5			; point last param
sf1a	move.w	sb.gtstr,a2
	jsr	(a2)			; try to get one string
	bne.s	errbp
	subq.w	#1,d3
	bne.s	errbp			; ... couldn't!
	move.l	a1,a0			; string rel to a6
	moveq	#0,d0
	move.w	(a6,a1.l),d0
	addq.l	#3,d0
	bclr	#0,d0
	add.l	d0,sb_arthp(a6)
	move.l	a0,a4			; pointer to name
	add.l	a6,a4
	move.l	d5,a5
	movem.l sndregs,-(a7)		; save regs
	sub.l	a1,a1			; start of job code
	moveq	#-1,d1			; it will belong to me, or not
	move.l	#100,d2 		; code space required
	move.l	#800,d3 		; data (stack) space
	moveq	#1,d0
	trap	#1			; set up sound job
	lea	-$10(a0),a3
	movem.l (a7)+,sndregs		; get old regs back
	moveq	#-1,d3
	lea	sndname,a1		; name of this job
	lea	sndjob,a2		; real start of this job
	move.w	#$4ef9,(a0)+
	move.l	a2,(a0)+		; make jump to our addresss
	move.w	#$4afb,(a0)+		; standard job marker
	moveq	#3,d2			; now copy job name
onlp1	move.l	(a1)+,(a0)+
	dbf	d2,onlp1
	move.l	a4,a1			; filename pointer
	move.w	(a1)+,d0		; in job data
	move.l	a0,a4			; keep
	move.w	d0,(a0)+		; copy now
	bra.s	docplp
cplp	move.b	(a1)+,(a0)+
docplp	dbf	d0,cplp 		; copy name for job
	movem.l d2-d7/a0-a5,-(a3)	; give this job my registers now (!)
	moveq	#0,d3			; don't wait for completion
	moveq	#10,d2			; priority
	moveq	#10,d0
	trap	#1			; start that job
	tst.l	d0
	bne.s	sf_out
	move.l	d1,d2
	bra	rt_fp
sf_out	rts
sndname
	dc.w	sndname2-*-2
	dc.b	'BD SOUNDFILE'
sndname2

; code for job itself
sndjob	move.l	a4,a0			; pointer to name
	move.l	#$8000,d4
	move.l	d4,d5
	subq.l	#2,d5
sf2	moveq	#ioa.open,d0
	moveq	#-1,d1			; channel belongs to me
	moveq	#ioa.kshr,d3		; open key: old; non exclusve, read only
	trap	#2			; try to open file
	move.l	d0,d6			; OK?
	bne.s	sepukku 		; ... no!
sf3	move.l	exv_i4,a3		; point to Interrupt level 4
	move.l	-(a3),a2		; this could be SSSS vector
	cmp.l	#sss.flag,-(a3) 	; is it really?
	bne.s	sepukku 		; ... no!
	moveq	#-1,d3			; file IO timeout

withbuf move.l	a2,-(a7)		; keep
	jsr	sss_setm(a2)		; set up multiple queue (A1 & A2 return)
	move.l	a2,d2			; end of queue
	move.l	(a7)+,a2
	sub.l	a1,d2			; that much space in sound queue
	ble.s	withbuf 		; none
	cmp.l	d5,d2			; for iob.fmul,D2 must fit in a word!
	ble.s	load			; ... ok
	move.l	d5,d2			; max amount permitted
load	moveq	#iob.fmul,d0
	trap	#3			; load bytes to (a1) returned from ssss_setm)
	move.l	d0,d6			; keep error
	move.l	a1,d1			; ignore error for now
	addq.l	#1,d1
	bclr	#0,d1
	move.l	d1,a1			; I want this always even
play	jsr	sss_addm(a2)		; add these bytes
	tst.l	d6			; load ok?
	beq.s	withbuf 		; yes, do more
	swap	d7
	tst.w	d7			; continue?
	beq.s	close			; ... no
	swap	d7
	moveq	#err.eof,d0
	cmp.l	d6,d0			; was error eof ?
	bne.s	close			; ... no, leave
	moveq	#0,d1
	moveq	#iof.posa,d0		; ... yes, restart at beginning of file
	trap	#3
wait_lp jsr	sss_sample(a2)
	cmp.l	d4,d0
	blt.s	withbuf
	movem.l d3/a0/a1,-(a7)
	moveq	#-1,d1
	moveq	#2,d3
	sub.l	a1,a1
	moveq	#8,d0
	trap	#1			; sleep a little
	movem.l (a7)+,d3/a0/a1
	bra.s	wait_lp

close	moveq	#ioa.clos,d0
	trap	#2			; close the file
	sub.w	#20,d7			; smsqmulator?
	bne.s	sepukku 		; ... no
	jsr	24(a2)			; ... yes, say no more sound forthcoming

sepukku moveq	#-1,d1			; remove myself
	moveq	#0,d3			; pretend no error occurred
	moveq	#sms.frjb,d0
	trap	#1
		    



	end
