****************************************************
*
; BouQLder QLash
; 32 bit integer -> Ascii
; (C) W. Lenerz 2018
*
*****************************************************

	section basic

	xdef	cvt_lng

; convert long +ive integer into ascii max 7 chars
; d0 c	r	<>0 if string should be left justified, 0 if right justified
;		length of string on return
; d1 c	s	integer to treat
; a1 c	s	ptr to END of where result string goes if right justified, or
;		ptr to start of string if left justified
; a2	s

lng_reg reg	d5-d7
cvt_lng movem.l lng_reg,-(a7)
	move.l	d1,d5
	ble.s	zero		; negative nbr = 0 !!!!!!!
	lea	table,a2
	cmp.l	(a2),d5
	bge.s	overflow	; too much
	moveq	#7,d1		; max nbr of chars
binlab	subq.w	#1,d1		; get rid of excess 0s
	cmp.l	(a2)+,d5	; at end, d1 = nbr of chars
	blt.s	binlab
	subq.l	#4,a2
	tst.l	d0		; right justify?
	bne.s	cvt_lab 	; ... no
not_min sub.l	d1,a1
cvt_lab move.l	d1,d0		; nbr of chars
	subq.w	#1,d1
binlop2 move.l	(a2)+,d7	; merci thierry!
	moveq	#-$30,d6
binlop3 sub.l	d7,d5
	dbmi	d6,binlop3	; sub this until neg (i.e. subbed too much)
	neg.b	d6
	move.b	d6,(a1)+	; figure now
	add.l	d7,d5		; overshot one
	dbra	d1,binlop2	; do it until no more...
	movem.l (a7)+,lng_reg
	rts

zero	tst.l	d0		: left justified?
	bne.s	zero1		; ... yes
	subq.l	#1,a1
zero1	move.b	#'0',(a1)
	moveq	#1,d0
	movem.l (a7)+,lng_reg
	rts

overflow
	moveq	#7,d1
	tst.l	d0
	bne.s	ov_left
	sub.l	d1,a1
ov_left moveq	#'*',d0
	subq.w	#1,d1
ov_lp	move.b	d0,(a1)+
	dbf	d1,ov_lp
	moveq	#9,d0
	movem.l (a7)+,lng_reg
	rts

table	dc.l	100000
table2	dc.l	10000
	dc.l	1000
	dc.l	100
	dc.l	10
	dc.l	1


	end
