****************************************************
*
; BouQLder QLash
; scan loop action routine : check a newly created space : a boulder/diamond might fall or roll into it
; (C) W. Lenerz 2018
*
*****************************************************


	section basic

	include 'dev1_basic_boulder_asm_keys'
	include 'dev8_keys_qdos_io'

	xdef	new_spc
	xdef	nw_spc2

	xref	chkbldr
	xref	chk4rol
	xref	chkdia
	xref	dia4rol
	xref	drw_blk
	xref	drw_spr

; d1-d3 s
; d4 c	p  sprite animation counter
; d5 c	p  loop counter (row|col)
; d7 c	p  loop delay | nbr of ticks before rescan for movement
; a0 c	p  screen address of variable area (after the steel walls)
; a1   s
; a2   s
; a3 c	p  timer address
; a4 c	p  ptr to NEXT element in array
; a5 c	p  workspace
; a6 c	p  basic ptr

new_spc bsr	drw_blk 		; draw space
; first check whether a boulder/diamond above newly created space should fall
nw_spc2 move.w	#space,-2(a4)		; and show it's space
	cmp.w	#boulder,-2-rowsize(a4) ; boulder above?
	bne.s	no_bldr 		; ... no, check for diamond above
	move.w	#-fallbdr,-2-rowsize(a4); ... yes, done
	rts
no_bldr cmp.w	#diamond,-2-rowsize(a4) ; diamond above?
	bne.s	chkroll 		; ... no, check for rolls
	move.w	#-falldia,-2-rowsize(a4); ... yes, done
	rts

; now check for rolls
; first check whether, due to the space just created, a boulder/diamond two
; rows up should roll
chkroll
	movem.l a1/d6,-(a7)
	move.l	d5,d0
	swap	d0
	sub.w	#nbrrows,d0		; are we in top row?
	beq.s	no_above		; yes, don't check 2 rows above....

	lea	-rowsize-4(a4),a1	; square one row above and to the left
	bsr	chkbldr 		; check boulder above left
	beq.s	out			; it rolls down, done
	bsr	chkdia			; check diamand above left
	beq.s	out			; it rolls down, done
	lea	-rowsize(a4),a1 	; square one row above and to the right
	bsr	chkbldr 		; check boulder above, right
	beq.s	out			; it rolls down, done
	lea	-rowsize(a4),a1 	; square one row above and to the right
	bsr	chkdia			; check diamond above, right
	beq.s	out			; it rolls down, done
no_above
	lea	-4(a4),a1		; square to the left
	bsr	chkbldr 		; check boulder left
	beq.s	out			; it rolls down, done
	bsr	chkdia			; check diamand  left
	beq.s	out			; it rolls down, done
							
	move.l	a4,a1			; square to the right
	bsr	chkbldr 		; check boulder right
	beq.s	out			; it rolls down, done
	move.l	a4,a1			; square to the right
	bsr	chkdia			; check diamond right
out	movem.l (a7)+,a1/d6
	moveq	#0,d0
	rts

	end



	move.l	a4,a1			; ... diamonds/boulders which might roll
	subq.l	#4,a1			; element to the left
	move.w	(a1),d6 		;
	subq.w	#boulder,d6		; is it a boulder?
	bne.s	dia_lft 		; ... no, try diamond
	bsr	chk4rol

right	move.l	a4,a1			; to the right
	move.w	(a1),d6 		;
	subq.w	#boulder,d6		;
	bne.s	dia_rit
	bsr	chk4rol
	lea	-rowsize(a4),a1
	bsr	chkbldr 		; check boulder above
out	movem.l  (a7)+,d6/a1
	moveq	#0,d0
	rts

dia_lft subq.w	#diamond-boulder,d6	; is it a diamond ?
	bne.s	right			; ... no, check right element
	bsr	dia4rol
	lea	 -rowsize-4(a4),a1
	bsr	chkdia
	bra.s	right
dia_rit subq.w	#diamond-boulder,d6	; is it a diamond?
	bne.s	out			; ... no, done
	bsr	dia4rol
	lea	 -rowsize(a4),a1
	bsr	chkdia
	bra.s	out

	end
