*************************************
*
; BouQLder QLash
; check for pan, pan if necessary
; (C) W. Lenerz 2018
*
**************************************

	section basic

	include 'dev1_basic_boulder_asm_keys'
	include 'dev8_keys_qlv'
	include 'dev8_keys_err'
	include 'dev8_keys_sbasic'
	include 'dev8_keys_qdos_io'
	include 'DEV8_keys_qdos_sms'

	xdef	chk_pan

; check whether I need to pan left or right
; on entry, d1 is the new position IN THE ARRAY
; all regs presered except d0,d6
pan_reg reg	d1-d7/a0-a4

pan_out moveq	#0,d0
	rts

chk_pan
	move.l	d1,d0
	sub.l	array(a5),d0		; relative to start of row#1 in array (not row 0)
	divu	#rowsize,d0		; col | row (within border!)
	swap	d0
	lsr.w	#1,d0
	addq.w	#1,d0			; col now
	move.w	startcol(a5),d6
	beq.s	pan_lft 		; no need to pan right
	sub.w	d6,d0			; how far from left adge am I?
					; d0 is now the dislay coloumn this would be iaplayed in
	cmp.w	#4,d0			; do I need to pan right (because I moved left)?
	bge.s	pan_lft2		; ... no, check left
	movem.l pan_reg,-(a7)
	subq.w	#1,d6			; new start column
	move.w	d6,startcol(a5) 	; set it
	bra.s	pan_right

; if I moved right, see whether I need to pan left
pan_lft2 add.w	d6,d0
pan_lft move.w	endcol(a5),d6
	cmp.w	#nbrcols,d6		; are we already displaying right border?
	beq.s	pan_out 		; yes, don't pan left
	sub.w	d0,d6
	cmp.w	#4,d6			; do I need to pan?
	bge.s	pan_out 		; ... no
	movem.l pan_reg,-(a7)
	addq.w	#1,endcol(a5)		; new end column
	move.w	endcol(a5),d6
	addq.w	#1,startcol(a5) 	; new start column
; pan left :
; move wdw one square to the left : take from column x+1 and put it in column x
; I don't need to pan rows 1 & 22, they're alway steel wall
pan_left
	move.w	scr_inc(a5),d4		; size of one screen line in bytes
	move.w	d4,d0
	mulu	sp_ysiz(a5),d0
	move.l	scr_off(a5),a1		; destination : x
	add.l	d0,a1			; one more row down
	move.l	a1,a2
	add.w	spr_lsz(a5),a2		; source : x + 1

	move.w	endcol(a5),d2
	sub.w	startcol(a5),d2 	; nbr of columns
	cmp.b	#16,display(a5) 	; mode 16?
	bne.s	nodiv			; ... no
	lsr.w	#1,d2			; ... yes, half the size in bytes
nodiv	subq.w	#1,d2			; prepare for dbf

	moveq	#20,d5			; nbr of rows
	mulu	sp_ysiz(a5),d5		; * nbr of lines per row
	subq.w	#1,d5			; prepare for dbf
						  
pl_lp1	move.l	a1,a3			; destination
	move.l	a2,a4			; source
	move.w	d2,d7			; nbr of iterations (LWs per line)
pl_lp2
	move.l	(a4)+,(a3)+		; copy
	move.l	(a4)+,(a3)+		; copy
	move.l	(a4)+,(a3)+		; copy
	move.l	(a4)+,(a3)+		; copy
	move.l	(a4)+,(a3)+		; copy
	move.l	(a4)+,(a3)+		; copy
	move.l	(a4)+,(a3)+		; copy
	move.l	(a4)+,(a3)+		; copied 1 (or 2 if mode 16) columns

	dbf	d7,pl_lp2		: do for all columns

	add.w	d4,a1			; move to next screen line, destn
	add.w	d4,a2			; same for source
	dbf	d5,pl_lp1		; do for all screen lines
	bra.s	new_col 		; draw new column

; pan right :
; move wdw one square right : take from column x-1 and put it in column x
; I don't need to pan rows 1 & 22, they're alway steel wall
pan_right
	move.w	scr_inc(a5),d4		; size of one screen line in bytes
	move.w	d4,d1
	mulu	sp_ysiz(a5),d1		; d1 = bytes for one row

	move.w	endcol(a5),d0
	sub.w	startcol(a5),d0 	; nbr of columns
	move.w	d0,d2
	subq.w	#1,d2			; end col wasn't adjusted yet
	mulu	spr_lsz(a5),d0		; nbr of screen bytes for all columns

	move.l	scr_off(a5),a1		; destination : x
	add.l	d0,a1
	add.l	d1,a1			; one row down
	move.l	a1,a2
	sub.w	spr_lsz(a5),a2		; source : x - 1

	moveq	#nbrrows-1,d3		; nbr of rows
	mulu	sp_ysiz(a5),d3		; * nbr of lines per row
	subq.w	#1,d3			; prepare for dbf

	cmp.b	#16,display(a5) 	; mode 16?
	bne.s	nodiv1			; ... no
	lsr.w	#1,d2			; ... yes, half the size in bytes
nodiv1	subq.w	#1,d2			; dbf

pr_lp1	move.l	a1,a3			; destination
	move.l	a2,a4			; source
	move.w	d2,d7			; nbr of long words per line

pr_lp2	move.l	-(a4),-(a3)		; copy
	move.l	-(a4),-(a3)		; copy
	move.l	-(a4),-(a3)		; copy
	move.l	-(a4),-(a3)		; copy
	move.l	-(a4),-(a3)		; copy
	move.l	-(a4),-(a3)		; copy
	move.l	-(a4),-(a3)		; copy
	move.l	-(a4),-(a3)		; copied 1 (or 2 if mode 16) columns
	
	dbf	d7,pr_lp2		; do for all columns

	add.w	d4,a1			; move to next screen line
	add.w	d4,a2
	dbf	d3,pr_lp1

	subq.w	#1,endcol(a5)		; new end col

; now draw the new column (col nbr in d6)
new_col move.l	array(a5),a4		; point to 1st elemnt in border
	sub.l	#rowsize+2,a4		; now fist element of border
	add.w	d6,a4
	add.w	d6,a4			; now first element to treat
	sub.w	startcol(a5),d6
	mulu	sp_xsiz(a5),d6		; sprite x size in pixels
	mulu	scr_byt(a5),d6		; nbr of bytes for one line of a sprite
					; = relative screen address for this col
	move.l	scr_off(a5),a0		; screen address of my window
	add.l	d6,a0			; absolute screen address for this col

	move.w	sp_ysiz(a5),d3		; nbr of screen lines in 1 sprite
	mulu	scr_inc(a5),d3		; * increase for 1 screen line

	move.w	scr_spinc(a5),d4	; screen line increase, minus 1 sprite

	move.w	scr_lop(a5),d7		; nbr of LWs to copy 1 sprite line

	moveq	#rowsize,d2		; size of one row in array, in bytes

	moveq	#nbrrows,d5		; there are 22 rows to draw

	move.l	spr_tbl(a5),a3		; sprite table for this screen mode
	move.l	spr_gen(a5),a2		; point to sprites

pan_lp	move.w	(a4),d0 		; element to draw
	add.w	d0,d0
	move.w	(a3,d0.w),d0		; index into sprites
	beq.s	pan_spc 		; none, draw empty space
	move.l	a2,a1			; point to sprites
	add.l	d0,a1			; this is the one we want
	move.w	sp_ysiz(a5),d0		; nbr of screen lines in 1 sprite
	subq.w	#1,d0			; dbf
spline	move.w	d7,d1
spcol	move.l	(a1)+,(a0)+
	dbf	d1,spcol		; copy sprite data directly into screen mem
	add.l	d4,a0			; next row of sprite in screen
	dbf	d0,spline		; do for all lines
nextrow add.w	d2,a4			; next row in array, same column
	dbf	d5,pan_lp
	bset	#0,panned(a5)
	movem.l (a7)+,pan_reg
	moveq	#0,d0
	rts
; draw empty square
pan_spc moveq	#0,d3			; colour = black
	move.w	sp_ysiz(a5),d0		; nbr of screen lines in 1 sprite
	subq.w	#1,d0			; dbf
sprow2	move.w	d7,d1
spcol2	move.l	d3,(a0)+
	dbf	d1,spcol2		; copy sprite data directly into screen mem
	add.l	d4,a0			; next row of sprite in screen
	dbf	d0,sprow2
	bra.s	nextrow
   
	end
